"use strict";

console.log("beginning program");

class MessageQueue {
	constructor() {
		this.container = [];
	}

	push(elem) {
		this.container.push(elem);
	}

	pop() {
		return this.container.pop();
	}

	length() {
		return this.container.length;
	}

	isEmpty() {
		return this.container.length === 0;
	}
}

var queue = new MessageQueue();

function pollForEventsInDOM() {
	if (!queue.isEmpty()) return queue.pop();
	return undefined;
}

function clearEventQueue() {
	while (!queue.isEmpty()) queue.pop();
}

//Functions to modify DOM from back-end
function switchView(viewName) {

	//acquire our elements by their class
	let mainView = document.getElementsByClassName("mainView")[0];
	let updateProgressView = document.getElementsByClassName("updateProgressView")[0];

	if (viewName === "mainView") {
		console.log("switching to main view");
		//Hide update progress view
		updateProgressView.className = "updateProgressView updateProgressViewHidden";
		//Make sure main view is not hidden
		mainView.className = "mainView";
	} else if (viewName === "updateProgressView") {
		console.log("switching to update progress view");
		//Dim the main window
		mainView.className = "mainView mainViewHidden";
		//Show update progress view
		updateProgressView.className = "updateProgressView";
	} else {
		return false; //if none of these match
	}
	return true;
}

function enableUpdaterButtons(newState) {
	let buttons = document.getElementsByClassName("btn");

	//if newState is 1, make button part of 'btn' class. Otherwise, give it 'btn disabled', 2 classes
	for (var i = 0; i < buttons.length; i++) {
		buttons[i].className = newState === 1 ? 'btn' : 'btn disabled';
	}
}

function updateGUITextBox(textBoxID, value) {
	//used to update any GUI text box on the page
	document.getElementById(textBoxID).innerHTML = value;
}

function updateProgressPercent(percentComplete) {
	document.getElementById("updateProgressPercent").innerHTML = String(percentComplete) + "%";
	document.getElementById("progressBar").value = percentComplete;
}
